;;;; AJL - slepe prehladavanie II, v2
;;; (C) MM, 2009

;;;; Zadanie: Prelievanie vody v nadobach    
;;;          
;;;  K dispozicii su dve nadoby, vacsia ma objem 4 l a mensia 3 l.      
;;;  Su na zaciatku prazdne, ulohou je dosiahnut, aby v malej
;;;  boli 2 litre, zatial co velka je prazdna.
;;;  Je mozne nadoby naplnit, vyprazdnit a prelievat vodu z jednej
;;;  nadoby do druhej.

;;;; Verzia 1 ******************************************************

(defun expanduj (stav)
  (cond
    ((equal stav '(0 . 0)) '((4 . 0) (0 . 3)))
    ((equal stav '(0 . 1)) '((0 . 0) (4 . 1) (0 . 3) (1 . 0)))
    ((equal stav '(0 . 2)) '((0 . 0) (4 . 2) (0 . 3) (2 . 0)))
    ((equal stav '(0 . 3)) '((0 . 0) (4 . 3) (3 . 0)))
    ((equal stav '(1 . 0)) '((0 . 0) (4 . 0) (1 . 3) (0 . 1)))
    ((equal stav '(1 . 1)) '((0 . 1) (1 . 0) (4 . 1) (1 . 3) (0 . 2) (2 . 0)))
    ((equal stav '(1 . 2)) '((0 . 2) (1 . 0) (4 . 2) (1 . 3) (0 . 3) (3 . 0)))
    ((equal stav '(1 . 3)) '((0 . 3) (1 . 0) (4 . 3) (4 . 0)))
    ((equal stav '(2 . 0)) '((0 . 0) (4 . 0) (2 . 3) (0 . 2)))
    ((equal stav '(2 . 1)) '((0 . 1) (2 . 0) (4 . 1) (2 . 3) (0 . 3) (3 . 0)))
    ((equal stav '(2 . 2)) '((0 . 2) (2 . 0) (4 . 2) (2 . 3) (1 . 3) (4 . 0)))
    ((equal stav '(2 . 3)) '((0 . 3) (2 . 0) (4 . 3) (4 . 1)))
    ((equal stav '(3 . 0)) '((0 . 0) (4 . 0) (3 . 3) (0 . 3)))
    ((equal stav '(3 . 1)) '((0 . 1) (3 . 0) (4 . 1) (3 . 3) (1 . 3) (4 . 0)))
    ((equal stav '(3 . 2)) '((0 . 2) (3 . 0) (4 . 2) (3 . 3) (4 . 1) (2 . 3)))
    ((equal stav '(3 . 3)) '((0 . 3) (3 . 0) (4 . 3) (4 . 2)))
    ((equal stav '(4 . 0)) '((0 . 0) (4 . 3) (1 . 3)))
    ((equal stav '(4 . 1)) '((0 . 1) (4 . 0) (4 . 3) (2 . 3)))
    ((equal stav '(4 . 2)) '((0 . 2) (4 . 0) (4 . 3) (3 . 3)))
    ((equal stav '(4 . 3)) '((0 . 3) (4 . 0)))))

(defparameter *open* '())
(defparameter *close* '())

(defun informuj (stav-na-expanziu nove-stavy mod)
  (when (> mod 0)
    (format t "~%exp: ~a~%" stav-na-expanziu)
    (format t "  gen: ~{ ~a ~}" nove-stavy))
  (when (> mod 1)
    (format t "~%  open:  ~{~a~^ ~a~^ ~a~^ ~a ~#[ ~:;~%         ~]~}" *open*)
    (format t "~%  close: ~{~a~^ ~a~^ ~a~^ ~a ~#[ ~:;~%         ~]~}" *close*)))

(defun hladaj (ciel vypis)
  (unless (equal *open* '())
    (let* ((stav-na-expanziu (pop *open*))
	   (nove-stavy (unless (member stav-na-expanziu *close* :test #'equal)
			 (expanduj stav-na-expanziu))))
      (push stav-na-expanziu *close*)
      (setf *open* (append *open* nove-stavy))
      (informuj stav-na-expanziu nove-stavy vypis)
      (if (member ciel nove-stavy :test #'equal)
	  t
	  (hladaj ciel vypis)))))

(defun ries (start ciel &optional (vypis 1))
  (setf *open* (list start))
  (setf *close* '())
  (unless (equal start ciel) (hladaj ciel vypis)))

;;;; Verzia 2 ******************************************************

(defun rovnake-stavy-p (uzol1 uzol2)
  (and (= (car (cdr uzol1)) (car (cdr uzol2)))
       (= (cdr (cdr uzol1)) (cdr (cdr uzol2)))))

(defun generuj-citac ()
  (let ((pamat 0))
    (lambda () (incf pamat))))

(defun ocisluj (stavy citac predok)
  (let ((predok-id (caar predok)))
    (mapcar #'(lambda (stav) (cons (cons (funcall citac) predok-id) stav))
	    stavy)))

(defun hladaj (ciel citac vypis)
  (unless (equal *open* '())
    (let* ((uzol-na-expanziu (pop *open*))
	   (nove-stavy (unless (member uzol-na-expanziu *close* 
				       :test #'rovnake-stavy-p)
			 (expanduj (cdr uzol-na-expanziu)))))
      (push uzol-na-expanziu *close*)
      (setf *open* (append *open*
			   (ocisluj nove-stavy citac uzol-na-expanziu)))
      (informuj uzol-na-expanziu nove-stavy vypis)
      (if (member ciel nove-stavy :test #'equal)
	  t
	  (hladaj ciel citac vypis)))))

(defun ries (start ciel &optional (vypis 1))
  (setf *open* (list (cons '(0 . 0) start)))
  (setf *close* '())
  (unless (equal start ciel) (hladaj ciel (generuj-citac) vypis)))

;;;; Verzia 3 ******************************************************

(defun ries (start ciel &optional (vypis 0))
  (setf *open* (list (cons '(0 . 0) start)))
  (setf *close* '())
  (unless (equal start ciel) (hladaj ciel (generuj-citac) vypis))
  (if (eql *open* '()) (format t "neviem najst riesenie~%") 
      (vytlac-cestu (cons t ciel))))

(defun vytlac-cestu (ciel)
  (let ((cesta (remove-if-not #'(lambda (x) (rovnake-stavy-p x ciel)) *open*)))
    (format t "~{  ~a ~%~}" (zostav-cestu cesta))))

(defun zostav-cestu (cesta)
  (let ((krok (caar (first cesta)))
	(predok-id (cdar (first cesta))))
    (if (= 0 krok)
	cesta
	(zostav-cestu
	 (cons (first (remove-if-not 
		       #'(lambda (x) (= (caar x) predok-id)) *close*))
	       cesta)))))

;;;; Verzia 4 ******************************************************

(defun hladaj (ciel citac vypis metoda)
  (unless (equal *open* '())
    (let* ((uzol-na-expanziu (pop *open*))
	   (nove-stavy (unless (member uzol-na-expanziu *close* 
				       :test #'rovnake-stavy-p)
			 (expanduj (cdr uzol-na-expanziu)))))
      (push uzol-na-expanziu *close*)
      (ccase metoda
	(:bf (setf *open* (append *open*
				  (ocisluj nove-stavy citac uzol-na-expanziu))))
	(:df (setf *open* (append (ocisluj nove-stavy citac uzol-na-expanziu)
					*open*))))
      (informuj uzol-na-expanziu nove-stavy vypis)
      (if (member ciel nove-stavy :test #'equal)
	  t
	  (hladaj ciel citac vypis metoda)))))

(defun ries (start ciel &key (vypis 0) (metoda :bf))
  (setf *open* (list (cons '(0 . 0) start)))
  (setf *close* '())
  (unless (equal start ciel) (hladaj ciel (generuj-citac) vypis metoda))
  (if (eql *open* '()) (format t "neviem najst riesenie~%")
      (vytlac-cestu (cons t ciel))))

;;;; Verzia 5 ******************************************************

;; povodna reprezentacia dot-listom

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (cons (cons uzol-id predok-id) stav))

(defun uzol>stav (uzol) (cdr uzol))
(defun uzol>uzol-id (uzol) (car (car uzol)))
(defun uzol>predok-id (uzol) (cdr (car uzol)))

;;; nasledujuci odsek by mali refaktorovat studenti

(defun rovnake-stavy-p (uzol1 uzol2)
  ...)

(defun ocisluj (stavy citac predok)
  ...)

(defun hladaj (ciel citac vypis metoda)
  ...)

(defun ries (start ciel &key (vypis 0) (metoda :bf))
  ...)

(defun zostav-cestu (cesta)
  ...)

;; pre kontrolu spravnosti - zmena reprezentacie na asociativny zoznam

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (list (cons 'stav stav) (cons 'uzol-id uzol-id) (cons 'predok-id predok-id)))

(defun uzol>stav (uzol) (rest (assoc 'stav uzol)))
(defun uzol>uzol-id (uzol) (rest (assoc 'uzol-id uzol)))
(defun uzol>predok-id (uzol) (rest (assoc 'predok-id uzol)))

;;;; Verzia 6 ******************************************************

;;; property list

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (list :stav stav :uzol-id uzol-id :predok-id predok-id))

(defun uzol>stav (uzol) (getf uzol :stav))
(defun uzol>uzol-id (uzol) (getf uzol :uzol-id))
(defun uzol>predok-id (uzol) (getf uzol :predok-id))

;;; vektor

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (vector stav uzol-id predok-id))

(defun uzol>stav (uzol) (svref uzol 0))
(defun uzol>uzol-id (uzol) (svref uzol 1))
(defun uzol>predok-id (uzol) (svref uzol 2))

;;; hash tabulka

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (let ((x (make-hash-table)))
    (setf (gethash 'stav x) stav)
    (setf (gethash 'uzol-id x) uzol-id)
    (setf (gethash 'predok-id x) predok-id)
    x))

(defun uzol>stav (uzol) (gethash 'stav uzol))
(defun uzol>uzol-id (uzol) (gethash 'uzol-id uzol))
(defun uzol>predok-id (uzol) (gethash 'predok-id uzol))

;;; struktura

(defstruct uzol
  stav uzol-id predok-id)

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (make-uzol :stav stav :uzol-id uzol-id :predok-id predok-id))

(defun uzol>stav (uzol) (uzol-stav uzol))
(defun uzol>uzol-id (uzol) (uzol-uzol-id uzol))
(defun uzol>predok-id (uzol) (uzol-predok-id uzol))

;;; objekt

(defclass uzol ()
  ((stav :initarg :stav :reader uzol>stav)
   (uzol-id :initarg :uzol-id :reader uzol>uzol-id)
   (predok-id :initarg :predok-id :reader uzol>predok-id)))

(defun novy-uzol (stav &optional (uzol-id nil) (predok-id nil))
  (make-instance 'uzol :stav stav :uzol-id uzol-id :predok-id predok-id))

